import sys,re, os,gc,zipfile, MySQLdb, pymysql, sqlalchemy, numpy as np, pandas as pd, pandas.io.sql as psql
import openpyxl, xlrd
# import xlsxwriter
import datetime, time, calendar
import zipfile
from zipfile import ZipFile
from os import remove
from sqlalchemy import create_engine
from openpyxl import load_workbook
from datetime import datetime, time, date, timedelta
from time import time, clock #importamos la función time para capturar tiempos
# from openpyxl.styles import Border, Side, PatternFill, Font, GradientFill, Alignment
# from openpyxl import load_workbook
# from openpyxl.drawing.image import Image
# import seaborn as sns, matplotlib.pyplot as plt,matplotlib
import MySQLdb as mysql 
import math,subprocess,redis

# def joinBy(x,fields):
#     return ', '.join(x[fields[0]] +' \$'+ x[fields[1]])

def validateAndCreateFolder(path):
    if os.path.exists(path):
        print('LOG: Se ha validado existencia del directorio', path)
    else:
        os.umask(0000) #autorizar permisos 777
        os.makedirs(path,0o777, exist_ok=True)# Crear recursivamente con permiso a solo lectura
        print('LOG: Se ha validado que no existía el directorio, se creó recursivamente', path)

def printException():
    import linecache,sys
    exc_type, exc_obj, tb = sys.exc_info()
    f = tb.tb_frame
    lineno = tb.tb_lineno
    filename = f.f_code.co_filename
    linecache.checkcache(filename)
    line = linecache.getline(filename, lineno, f.f_globals)
    print ('ErrorException \nFILE:{}, \nLINE: {} \nCODE: {}.\nType: {}.\nDetails: {}'.format(filename, lineno, line.strip(), exc_type,exc_obj))

def mes_actual_en_letras(mes_to_string):
    mesesDic = {
        "1":'Enero',
        "2":'Febrero',
        "3":'Marzo',
        "4":'Abril',
        "5":'Mayo',
        "6":'Junio',
        "7":'Julio',
        "8":'Agosto',
        "9":'Septiembre',
        "10":'Octubre',
        "11":'Noviembre',
        "12":'Diciembre'
    }
    return mesesDic[str(mes_to_string)]

def sumar_columnas(df, columna, lista_a_sumar):
    df[columna] = df[lista_a_sumar].astype(float).sum(axis=1)
    return(df)

def columnas_tolist(df,columna=''):
    if (columna==''):
        return str(df.columns.values.tolist()).replace("[", "").replace("]", "").replace(" ", "\n<br>").replace("'", "")
    else:
        return str(df[columna].values.tolist()).replace('[','').replace(']','').replace(',','\n<br>').replace("'", "")

# def vaciar_memoria(df):
#     del [[df]]
#     gc.collect()
#     return pd.DataFrame()     

def consultar_tabla(query, engine, chunk_size=15000,delete_before=False,only_csv=False,ruta_csv='',params={},chunksize=100000):
    try:
        engine
    except NameError:
        print("LOG:ERROR, engine no esta definido, asigne el engine como segundo parametro")
    else:
        start_query = inicio_ejecucion('INICIO QUERY')
        if delete_before:
            if os.path.isfile(ruta_csv):
                print('Eliminando archivo encontrado', ruta_csv)
                remove(ruta_csv)
                print('ELIMINADO')
        offset = 0
        df = []
        dfs = []
        print(query)
        tamano = chunk_size
        while ( tamano == chunk_size ):
            bloque_actual = """ LIMIT {0} OFFSET {1}""".format(chunk_size,offset) 
            q = query + bloque_actual
            print('BLOQUE ACTUAL =>', bloque_actual)
            df = psql.read_sql(sqlalchemy.text( q ), engine,params=params)
            if only_csv:
                appendDFToCSV(df, ruta_csv, sep=';',chunksize=chunksize)
            else:
                dfs.append(df)
            print('Cantidad encontrada:', len(df) )
            offset += chunk_size
            tamano = len(df)
        if only_csv == False:
            full_df = pd.concat(dfs).reset_index(drop=True)
            end_query = fin_ejecucion('FINALIZO QUERY',start_query)
            return full_df
        end_query = fin_ejecucion('FINALIZO QUERY',start_query)
        

def validar_0_df(df,nombre_campo):
    return df[nombre_campo].astype( str ).str.replace(".0", "").replace("nan", "",regex=False).replace("none", "",regex=False).str.strip()

def validar_fechauhora_df(df,nombre_campo,tipo_de_dato='hora',corregir_hora_to_reporte=False,formato='ymd'):
    if (tipo_de_dato == 'hora'):
        if(corregir_hora_to_reporte):
            return df[nombre_campo].astype(str).replace("0 days ","",regex=True).replace("\..+","",regex=True)
        else:
            df[nombre_campo].fillna('00:00:00',inplace=True)
            return pd.to_timedelta(df[nombre_campo])
    elif (tipo_de_dato == 'dayofweek'):
        return pd.to_datetime(df[nombre_campo])
    elif (tipo_de_dato == 'fecha'):
        if (formato == 'ymd'):
            return pd.to_datetime(df[nombre_campo], format='%Y-%m-%d', errors='coerce').dt.date
        else:
            return pd.to_datetime(df[nombre_campo], format='%Y-%m-%d', errors='coerce').dt.strftime('%d-%m-%Y')
    else:
        print('LOG: ERROR, usted ha definido un tipo de dato que no existe, solo se reciben como 2do parametro tipo_de_dato => hora,dayofweek,fecha')
        return df[nombre_campo]

def ObtenerDuracionEjecucion(sec): 
    from datetime import datetime
    sec = timedelta(seconds=int(sec)) 
    d = datetime(1,1,1) + sec 
    respuesta = "%d hr:%d min:%d seg" % (d.hour,d.minute, d.second)
    return respuesta

def inicio_ejecucion(texto_to_print):
    from datetime import datetime, time, date, timedelta
    print ('##########################################################################################')
    start_date = datetime.strptime(datetime.now().strftime('%Y-%m-%d %H:%M:%S'), '%Y-%m-%d %H:%M:%S')
    print( texto_to_print + ':', start_date )
    return start_date

def fin_ejecucion(texto_to_print, start_date):
    from datetime import datetime, time, date, timedelta
    stop_date = datetime.strptime(datetime.now().strftime('%Y-%m-%d %H:%M:%S'), '%Y-%m-%d %H:%M:%S')
    tiempo_ejecucion = (stop_date - start_date).seconds

    if texto_to_print=='':
        return ObtenerDuracionEjecucion(tiempo_ejecucion)
    else:
        print( texto_to_print + ':', stop_date )

        print ('La duracion de ejecucion fue: ' + ObtenerDuracionEjecucion( tiempo_ejecucion ) + ' segundos') #En segundos
        print ('##########################################################################################')
        return ObtenerDuracionEjecucion(tiempo_ejecucion)
def ultimo_dia_mes(ano_actual_nro,mes_actual_nro):
    import datetime
    today=datetime.datetime.now()
    dia=calendar.monthrange(ano_actual_nro, mes_actual_nro)[1]
    return dia

def restar_fechas(fecha1, fecha2):
    import datetime
    start_date = datetime.datetime.strptime(fecha1, '%H:%M:%S')
    end_date = datetime.datetime.strptime(fecha2, '%H:%M:%S')
    diff = end_date - start_date
    return diff.seconds

def ObtenerDuracionHMS(sec): 
    from datetime import datetime
    return (datetime(1,1,1) + timedelta(seconds=int(sec))).strftime("%H:%M:%S")

def mes_a_letras(mes_to_string):
    mes_to_string = str(mes_to_string)
    if mes_to_string != "10":
        mes_to_string = mes_to_string.replace('0','')
    mesesDic = {
        "1":'Enero',
        "2":'Febrero',
        "3":'Marzo',
        "4":'Abril',
        "5":'Mayo',
        "6":'Junio',
        "7":'Julio',
        "8":'Agosto',
        "9":'Septiembre',
        "10":'Octubre',
        "11":'Noviembre',
        "12":'Diciembre'
    }
    return mesesDic[str(mes_to_string)]

def consulta_to_csv(query,chunk_size=10000,ruta='GTA.csv',engine=''):
    if (engine == ''):
        print("LOG:ERROR, engine no esta definido, asigne el engine como segundo parametro")
    else:
        start_date = inicio_ejecucion('FECHA INICIO consultar_tabla_to_csv')
        offset = 0
        full_df = pd.DataFrame()
        df = pd.DataFrame()

        print(query)
        tamano = chunk_size
        
        while ( tamano == chunk_size ):
            start_date_interno = inicio_ejecucion('INICIANDO CONSULTAS POR CHUNKSIZE')
            bloque_actual = """ LIMIT {0} OFFSET {1}""".format(chunk_size,offset) 
            q = query + bloque_actual
            print('BLOQUE ACTUAL =>', bloque_actual)
            df = psql.read_sql(sqlalchemy.text( q ), engine)
            tamano = len(df)
            print('Cantidad encontrada:', tamano )
            # INICIO quitar espacios en blanco a los costados y .0 al final
            df['SEGMENTO'] = validar_0_df(df,'SEGMENTO')
            df['ID_RESULTADO'] = validar_0_df(df,'ID_RESULTADO')
            df['PRODUCTO1'] = validar_0_df(df,'PRODUCTO1')
            df['IDENTIFICACION'] = validar_0_df(df,'IDENTIFICACION')
            df['TELEFONO'] = validar_0_df(df,'TELEFONO')
            # FIN quitar espacios en blanco a los costados y .0 al final
            # INICIO dar formato de fecha y hora a campos
            df['fecha_llamada'] = validar_fechauhora_df(df,'fecha_llamada','fecha')
            df['hora_llamada'] = validar_fechauhora_df(df,'hora_llamada')
            df['hora_contestacion'] = validar_fechauhora_df(df,'hora_contestacion')
            df['hora_fin_llamada'] = validar_fechauhora_df(df,'hora_fin_llamada')
            # FIN dar formato de fecha y hora a campos
            
            appendDFToCSV(df, ruta, sep=';')
            
            print ('##########################################################################################')
            print('INICIO DE: segmentacion del DataFrame hacia CSV')
            #ciclo for por segmento
            
            if ( df['SEGMENTO'].dtype == np.int ):
                tipo_de_dato_segmento = 'int'
            else:
                tipo_de_dato_segmento = 'str'
            
            if ( len(df.groupby(['SEGMENTO']).head(1).sort_values('SEGMENTO')) ) > 0:
                for index, row in df.groupby(['SEGMENTO']).head(1).sort_values('SEGMENTO').iterrows():
                    if ( tipo_de_dato_segmento == 'int' ):
                        print('el tipo de dato del la columna SEGMENTO es entero')
                        segmento_for = int(row['SEGMENTO'])
                        valores = df_segmentos.id.values
                    else:
                        segmento_for = str(row['SEGMENTO'])
                        valores = df_segmentos.nombre.values
                    if segmento_for in valores:
                        if (tipo_de_dato_segmento == 'int'):
                            segmento_id = df_segmentos[df_segmentos.id.isin( [segmento_for] )].reset_index(drop=True).id[0]
                            segmento_nombre = df_segmentos[df_segmentos.id.isin( [segmento_for] )].reset_index(drop=True).nombre[0]
                        else:
                            segmento_id = df_segmentos[df_segmentos.nombre.isin( [segmento_for] )].reset_index(drop=True).id[0]
                            segmento_nombre = df_segmentos[df_segmentos.nombre.isin( [segmento_for] )].reset_index(drop=True).nombre[0]
    #                     segmento_id = df_segmentos[df_segmentos.id.isin( [segmento_for] )].reset_index(drop=True).id[0]
                    else:
                        print('segmento no encontrado en tabla segmentos')
                        segmento_nombre = row['SEGMENTO']
                        segmento_id = row['SEGMENTO']

                    print( 'INICIO ' + segmento_nombre , segmento_id )
                    ruta_archivo = ruta_principal+"""{1}{0}{2}{0}{3}.csv""".format(sep_archivo,nombre_gta,segmento_nombre, mes_actual_nom)
                    print( 'Registros encontrados:', len( df[ df.SEGMENTO.isin( [ segmento_for ] ) ].reset_index(drop=True) ) )
                    appendDFToCSV( df[ df.SEGMENTO.isin( [ segmento_for ] ) ].reset_index(drop=True),
                                       ruta_archivo, sep=";")
                    print( 'FIN ' + segmento_nombre , segmento_id )

            print('FIN DE: segmentacion del DataFrame hacia CSV')
            print ('##########################################################################################')
            
            offset += chunk_size
            fin_ejecucion('FINALIZADA CONSULTAS POR CHUNKSIZE',start_date_interno)
            
            del [[df]]
            gc.collect()
            df=pd.DataFrame()
            df = None
            
        fin_ejecucion('FECHA FIN consultar_to_csv',start_date)

def appendDFToCSV(df, csvFilePath, sep=";",chunksize=100000):
    if os.path.isfile(csvFilePath):
        print('El csv EXISTE',csvFilePath)
        with open(csvFilePath, 'a') as f:
            print( f.tell() )
            df.replace("\r","",regex=True).replace("\t","",regex=True).replace("\n","",regex=True).to_csv(f,index=False, sep=sep, header=False,line_terminator="\r\n",chunksize=chunksize)
    else:
        print('El csv NO EXISTE',csvFilePath)
        df.replace("\r","",regex=True).replace("\t","",regex=True).replace("\n","",regex=True).to_csv(csvFilePath,index=False, sep=sep, header=True,line_terminator="\r\n",chunksize=chunksize)
    del [[df]]
    gc.collect()
    df=pd.DataFrame()
    df = None

def validar_tabla(tablename,json):
    try:
        query = """
                SELECT COUNT(*) FROM information_schema.tables
                WHERE table_name = '{0}' AND table_schema ='{1}'
                """.format(tablename.replace('\'', '\'\''),json['db'])
        connection = mysql.connect(host=json['host'],
                         user=json['user'],
                         passwd=json['pw'],
                         db=json['db'])
        cursor = connection.cursor()

        cursor.execute(query)
        result = cursor.fetchone()[0]  
        cursor.close()
        return result
    except:
        printException()

def executeQuery(query,json):
    try:
        connection = mysql.connect(host=json['host'],
                         user=json['user'],
                         passwd=json['pw'],
                         db=json['db'])
        cursor = connection.cursor()
        cursor.execute(query)
        result = cursor.fetchone()[0]     
        return result
    except:
        printException()
        
def mysqlConnection(tablename,json):
    import mysql.connector
    from mysql.connector import Error
    connection = mysql.connector.connect(host=json['host'],
                         user=json['user'],
                         passwd=json['pw'],
                         db=json['db'])
    return connection
def replace_espacios(arr,w_to__=False):
    arr = [word.strip() for word in arr]
    arr = [ " ".join(word.split()) for word in arr]
    if w_to__:
        return [word.replace(' ','_') for word in arr]
    else:
        return arr
    